diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
index 5eaa60091..341d80797 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
@@ -15,7 +15,8 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHead> {
-    protected IconCoordinate pistonSide;
+    protected IconCoordinate pistonHead;
+    protected IconCoordinate pistonShaft;
     protected IconCoordinate pistonDry = TextureRegistry.getTexture("minecraft:block/piston/face");
     protected IconCoordinate pistonSticky = TextureRegistry.getTexture("minecraft:block/piston_sticky/face");
     protected IconCoordinate pistonSteel = TextureRegistry.getTexture("minecraft:block/piston_steel/face");
@@ -23,14 +24,17 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
     public IconCoordinate faceTextureOverride;
 
     protected final double headThickness;
-    public BlockModelPistonHead(Block<BlockLogicPistonHead> block, IconCoordinate pistonSide) {
-        this(block, pistonSide, 4/16d);
+    protected final double shaftThickness;
+    public BlockModelPistonHead(final Block<BlockLogicPistonHead> block, final IconCoordinate pistonHead, final IconCoordinate pistonShaft) {
+        this(block, pistonHead, pistonShaft, 4/16d, 4/16d);
     }
 
-    public BlockModelPistonHead(Block<BlockLogicPistonHead> block, IconCoordinate pistonSide, double headThickness) {
+    public BlockModelPistonHead(final Block<BlockLogicPistonHead> block, final IconCoordinate pistonHead, final IconCoordinate pistonShaft, final double headThickness, final double shaftThickness) {
         super(block);
-        this.pistonSide = pistonSide;
+        this.pistonHead = pistonHead;
+        this.pistonShaft = pistonShaft;
         this.headThickness = headThickness;
+        this.shaftThickness = shaftThickness;
     }
 
     @Override
@@ -42,8 +46,8 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
         renderPistonHead(tessellator, worldSource, block, x, y, z, flag);
         renderBlocks.renderAllFaces = false;
     }
-    public void setFaceTextureOverride(@Nullable IconCoordinate faceTexture){
-        faceTextureOverride = faceTexture;
+    public void setFaceTextureOverride(@Nullable final IconCoordinate faceTexture){
+        this.faceTextureOverride = faceTexture;
     }
     protected boolean renderPistonHead(Tessellator tessellator, WorldSource worldSource, Block<BlockLogicPistonHead> block, int x, int y, int z, boolean flag) {
         int metadata = worldSource.getBlockMetadata(x, y, z);
@@ -54,8 +58,8 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
         }else {
         	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
         }
-        float f1 = flag ? 1.0F : 0.5F;
-        double width = flag ? 1 : 1/2d;
+        final float f1 = flag ? 1.0F : 0.5F;
+        final double width = flag ? 1 : 1/2d;
         switch(direction)
         {
             case DOWN: // BOTTOM
@@ -63,29 +67,29 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateWest = 3;
                 renderBlocks.uvRotateSouth = 3;
                 renderBlocks.uvRotateNorth = 3;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F), x, y, z);
-                renderHeadTopBottom(tessellator, x + 0.375F, x + 0.625F, y + headThickness, y + headThickness + f1, z + 0.625F, z + 0.625F, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, x + 0.625F, x + 0.375F, y + headThickness, y + headThickness + f1, z + 0.375F, z + 0.375F, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, x + 0.375F, x + 0.375F, y + headThickness, y + headThickness + f1, z + 0.375F, z + 0.625F, brightness * 0.6F, width);
-                renderHeadTopBottom(tessellator, x + 0.625F, x + 0.625F, y + headThickness, y + headThickness + f1, z + 0.625F, z + 0.375F, brightness * 0.6F, width);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F), x, y, z);
+                renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 + this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 - this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.6F, width);
+                renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.6F, width);
                 break;
 
             case UP: // TOP
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
-                renderHeadTopBottom(tessellator, x + 0.375F, x + 0.625F, ((y - headThickness) + 1.0F) - f1, (y - headThickness) + 1.0F, z + 0.625F, z + 0.625F, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, x + 0.625F, x + 0.375F, ((y - headThickness) + 1.0F) - f1, (y - headThickness) + 1.0F, z + 0.375F, z + 0.375F, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, x + 0.375F, x + 0.375F, ((y - headThickness) + 1.0F) - f1, (y - headThickness) + 1.0F, z + 0.375F, z + 0.625F, brightness * 0.6F, width);
-                renderHeadTopBottom(tessellator, x + 0.625F, x + 0.625F, ((y - headThickness) + 1.0F) - f1, (y - headThickness) + 1.0F, z + 0.625F, z + 0.375F, brightness * 0.6F, width);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
+                renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 + this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 - this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.6F, width);
+                renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.6F, width);
                 break;
 
             case NORTH: // NORTH
                 renderBlocks.uvRotateSouth = 1;
                 renderBlocks.uvRotateNorth = 2;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness), x, y, z);
-                renderHeadNorthSouth(tessellator, x + 0.375F, x + 0.375F, y + 0.625F, y + 0.375F, z + headThickness, z + headThickness + f1, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, x + 0.625F, x + 0.625F, y + 0.375F, y + 0.625F, z + headThickness, z + headThickness + f1, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, x + 0.375F, x + 0.625F, y + 0.375F, y + 0.375F, z + headThickness, z + headThickness + f1, brightness * 0.5F, width);
-                renderHeadNorthSouth(tessellator, x + 0.625F, x + 0.375F, y + 0.625F, y + 0.625F, z + headThickness, z + headThickness + f1, brightness, width);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness), x, y, z);
+                renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + this.headThickness, z + this.headThickness + f1, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + this.headThickness, z + this.headThickness + f1, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + this.headThickness, z + this.headThickness + f1, brightness * 0.5F, width);
+                renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + this.headThickness, z + this.headThickness + f1, brightness, width);
                 break;
 
             case SOUTH: // SOUTH
@@ -93,11 +97,11 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateNorth = 1;
                 renderBlocks.uvRotateTop = 3;
                 renderBlocks.uvRotateBottom = 3;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F), x, y, z);
-                renderHeadNorthSouth(tessellator, x + 0.375F, x + 0.375F, y + 0.625F, y + 0.375F, ((z - headThickness) + 1.0F) - f1, (z - headThickness) + 1.0F, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, x + 0.625F, x + 0.625F, y + 0.375F, y + 0.625F, ((z - headThickness) + 1.0F) - f1, (z - headThickness) + 1.0F, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, x + 0.375F, x + 0.625F, y + 0.375F, y + 0.375F, ((z - headThickness) + 1.0F) - f1, (z - headThickness) + 1.0F, brightness * 0.5F, width);
-                renderHeadNorthSouth(tessellator, x + 0.625F, x + 0.375F, y + 0.625F, y + 0.625F, ((z - headThickness) + 1.0F) - f1, (z - headThickness) + 1.0F, brightness, width);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F), x, y, z);
+                renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness * 0.5F, width);
+                renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness, width);
                 break;
 
             case WEST: // WEST
@@ -105,11 +109,11 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateWest = 2;
                 renderBlocks.uvRotateTop = 2;
                 renderBlocks.uvRotateBottom = 1;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F), x, y, z);
-                renderHeadEastWest(tessellator, x + headThickness, x + headThickness + f1, y + 0.375F, y + 0.375F, z + 0.625F, z + 0.375F, brightness * 0.5F, width);
-                renderHeadEastWest(tessellator, x + headThickness, x + headThickness + f1, y + 0.625F, y + 0.625F, z + 0.375F, z + 0.625F, brightness, width);
-                renderHeadEastWest(tessellator, x + headThickness, x + headThickness + f1, y + 0.375F, y + 0.625F, z + 0.375F, z + 0.375F, brightness * 0.6F, width);
-                renderHeadEastWest(tessellator, x + headThickness, x + headThickness + f1, y + 0.625F, y + 0.375F, z + 0.625F, z + 0.625F, brightness * 0.6F, width);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F), x, y, z);
+                renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 - this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.5F, width);
+                renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 + this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness, width);
+                renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.6F, width);
+                renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.6F, width);
                 break;
 
             case EAST: // EAST
@@ -117,68 +121,56 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateWest = 1;
                 renderBlocks.uvRotateTop = 1;
                 renderBlocks.uvRotateBottom = 2;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
-                renderHeadEastWest(tessellator, ((x - headThickness) + 1.0F) - f1, (x - headThickness) + 1.0F, y + 0.375F, y + 0.375F, z + 0.625F, z + 0.375F, brightness * 0.5F, width);
-                renderHeadEastWest(tessellator, ((x - headThickness) + 1.0F) - f1, (x - headThickness) + 1.0F, y + 0.625F, y + 0.625F, z + 0.375F, z + 0.625F, brightness, width);
-                renderHeadEastWest(tessellator, ((x - headThickness) + 1.0F) - f1, (x - headThickness) + 1.0F, y + 0.375F, y + 0.625F, z + 0.375F, z + 0.375F, brightness * 0.6F, width);
-                renderHeadEastWest(tessellator, ((x - headThickness) + 1.0F) - f1, (x - headThickness) + 1.0F, y + 0.625F, y + 0.375F, z + 0.625F, z + 0.625F, brightness * 0.6F, width);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
+                renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 - this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.5F, width);
+                renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 + this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness, width);
+                renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.6F, width);
+                renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.6F, width);
                 break;
         }
         renderBlocks.resetRenderBlocks();
         return true;
     }
-    private void renderHeadTopBottom(Tessellator tessellator, double xMin, double xMax, double yMin, double yMax, double zMin, double zMax, float brightness, double width)
+    private void renderHeadTopBottom(final Tessellator tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width)
     {
-        IconCoordinate i = pistonSide;
-        if(renderBlocks.overrideBlockTexture != null)
-        {
-            i = renderBlocks.overrideBlockTexture;
-        }
-        double uMin = i.getIconUMin();
-        double vMin = i.getIconVMin();
-        double uMax = i.getSubIconU(width);
-        double vMax = i.getSubIconV(1/4f);
+        final IconCoordinate i = renderBlocks.overrideBlockTexture != null ? renderBlocks.overrideBlockTexture : this.pistonShaft;
+        final double uMin = i.getSubIconU(0.5 - this.shaftThickness/2);
+        final double vMin = i.getIconVMin();
+        final double uMax = i.getSubIconU(0.5 + this.shaftThickness/2);
+        final double vMax = i.getSubIconV(width);
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
-        tessellator.addVertexWithUV(xMin, yMax, zMin, uMax, vMin);
-        tessellator.addVertexWithUV(xMin, yMin, zMin, uMin, vMin);
-        tessellator.addVertexWithUV(xMax, yMin, zMax, uMin, vMax);
-        tessellator.addVertexWithUV(xMax, yMax, zMax, uMax, vMax);
+        tessellator.addVertexWithUV(xMin, yMax, zMin, uMax, vMax);
+        tessellator.addVertexWithUV(xMin, yMin, zMin, uMax, vMin);
+        tessellator.addVertexWithUV(xMax, yMin, zMax, uMin, vMin);
+        tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMax);
     }
 
-    private void renderHeadNorthSouth(Tessellator tessellator, double xMin, double xMax, double yMin, double yMax, double zMin, double zMax, float brightness, double width)
+    private void renderHeadNorthSouth(final Tessellator tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width)
     {
-        IconCoordinate i = pistonSide;
-        if(renderBlocks.overrideBlockTexture != null)
-        {
-            i = renderBlocks.overrideBlockTexture;
-        }
-        double uMin = i.getIconUMin();
-        double vMin = i.getIconVMin();
-        double uMax = i.getSubIconU(width);
-        double vMax = i.getSubIconV(1/4f);
+        final IconCoordinate i = renderBlocks.overrideBlockTexture != null ? renderBlocks.overrideBlockTexture : this.pistonShaft;
+        final double uMin = i.getSubIconU(0.5 - this.shaftThickness/2);
+        final double vMin = i.getIconVMin();
+        final double uMax = i.getSubIconU(0.5 + this.shaftThickness/2);
+        final double vMax = i.getSubIconV(width);
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
-        tessellator.addVertexWithUV(xMin, yMin, zMax, uMax, vMin);
-        tessellator.addVertexWithUV(xMin, yMin, zMin, uMin, vMin);
-        tessellator.addVertexWithUV(xMax, yMax, zMin, uMin, vMax);
-        tessellator.addVertexWithUV(xMax, yMax, zMax, uMax, vMax);
+        tessellator.addVertexWithUV(xMin, yMin, zMax, uMax, vMax);
+        tessellator.addVertexWithUV(xMin, yMin, zMin, uMax, vMin);
+        tessellator.addVertexWithUV(xMax, yMax, zMin, uMin, vMin);
+        tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMax);
     }
 
-    private void renderHeadEastWest(Tessellator tessellator, double xMin, double xMax, double yMin, double yMax, double zMin, double zMax, float brightness, double width)
+    private void renderHeadEastWest(final Tessellator tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width)
     {
-        IconCoordinate i = pistonSide;
-        if(renderBlocks.overrideBlockTexture != null)
-        {
-            i = renderBlocks.overrideBlockTexture;
-        }
-        double uMin = i.getIconUMin();
-        double vMin = i.getIconVMin();
-        double uMax = i.getSubIconU(width);
-        double vMax = i.getSubIconV(1/4f);
+        final IconCoordinate i = renderBlocks.overrideBlockTexture != null ? renderBlocks.overrideBlockTexture : this.pistonShaft;
+        final double uMin = i.getSubIconU(0.5 - this.shaftThickness/2);
+        final double vMin = i.getIconVMin();
+        final double uMax = i.getSubIconU(0.5 + this.shaftThickness/2);
+        final double vMax = i.getSubIconV(width);
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
-        tessellator.addVertexWithUV(xMax, yMin, zMin, uMax, vMin);
-        tessellator.addVertexWithUV(xMin, yMin, zMin, uMin, vMin);
-        tessellator.addVertexWithUV(xMin, yMax, zMax, uMin, vMax);
-        tessellator.addVertexWithUV(xMax, yMax, zMax, uMax, vMax);
+        tessellator.addVertexWithUV(xMax, yMin, zMin, uMax, vMax);
+        tessellator.addVertexWithUV(xMin, yMin, zMin, uMax, vMin);
+        tessellator.addVertexWithUV(xMin, yMax, zMax, uMin, vMin);
+        tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMax);
     }
     @Override
     public boolean shouldItemRender3d() {
@@ -187,23 +179,23 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
     @Override
     public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        Direction direction = BlockLogicPistonHead.getDirectionFromMeta(data);
+        final Direction direction = BlockLogicPistonHead.getDirectionFromMeta(data);
         if(side.getDirection() == direction)
         {
-            if(faceTextureOverride != null)
+            if(this.faceTextureOverride != null)
             {
-                return faceTextureOverride;
+                return this.faceTextureOverride;
             }
             switch (BlockLogicPistonHead.getPistonType(data)) {
                 case BlockLogicPistonHead.TYPE_NORMAL:
-                    return pistonDry;
+                    return this.pistonDry;
                 case BlockLogicPistonHead.TYPE_STICKY:
-                    return pistonSticky;
+                    return this.pistonSticky;
                 case BlockLogicPistonHead.TYPE_STEEL:
-                    return pistonSteel;
+                    return this.pistonSteel;
             }
         }
-        boolean isSteel = block == Blocks.PISTON_HEAD_STEEL; // Todo this is just awful
-        return side.getDirection() != direction.getOpposite() ? pistonSide : ((isSteel) ? pistonSteel : pistonDry); // TODO remove this horrid ternary
+        final boolean isSteel = this.block == Blocks.PISTON_HEAD_STEEL; // Todo this is just awful
+        return side.getDirection() != direction.getOpposite() ? this.pistonHead : ((isSteel) ? this.pistonSteel : this.pistonDry); // TODO remove this horrid ternary
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index 097fe7176..14fea3262 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -428,10 +428,10 @@ public final class RenderBlocks
         double d10 = d6;
         if(uvRotateBottom == 2)
         {
-            d3 = tex.getSubIconU(bounds.minX);
+            d3 = tex.getSubIconU(bounds.minZ);
             d5 = tex.getSubIconV(1 - bounds.maxX);
             d4 = tex.getSubIconU(bounds.maxZ);
-            d6 = tex.getSubIconV(1 - bounds.minZ);
+            d6 = tex.getSubIconV(1 - bounds.minX);
             d9 = d5;
             d10 = d6;
             d7 = d3;
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTextureProperties.java b/game/client/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTextureProperties.java
index 28ae55403..7a4ef415b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTextureProperties.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/meta/gui/GuiTextureProperties.java
@@ -1,5 +1,8 @@
 package net.minecraft.client.render.texture.meta.gui;
 
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
 public class GuiTextureProperties {
     public static final String TYPE_STRETCH = "stretch";
     public static final String TYPE_TILE = "tile";
@@ -11,7 +14,7 @@ public class GuiTextureProperties {
     public final Border border;
     public final boolean stretchInner;
 
-    public GuiTextureProperties(String type, int width, int height, Border border, boolean stretchInner) {
+    public GuiTextureProperties(@NotNull final String type, final int width, final int height, @Nullable final Border border, final boolean stretchInner) {
         this.type = type;
         this.width = width;
         this.height = height;
@@ -25,11 +28,11 @@ public class GuiTextureProperties {
         public final int right;
         public final int bottom;
 
-        public Border(int size) {
-            left = top = right = bottom = size;
+        public Border(final int size) {
+            this.left = this.top = this.right = this.bottom = size;
         }
 
-        public Border(int left, int top, int right, int bottom) {
+        public Border(final int left, final int top, final int right, final int bottom) {
             this.left = left;
             this.top = top;
             this.right = right;
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
index 1d9ab4b49..f4f856b27 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePack.java
@@ -14,6 +14,7 @@ import java.util.stream.Stream;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.holiday.Holidays;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 public abstract class TexturePack {
@@ -44,7 +45,7 @@ public abstract class TexturePack {
 	{
 	}
 
-	public InputStream getResourceAsStream(String s)
+	public @Nullable InputStream getResourceAsStream(String s)
 	{
 		if (Holidays.getCurrentThemedHoliday() != null && Minecraft.getMinecraft().gameSettings.enableHolidayTextures.value) {
 			assert Holidays.getCurrentThemedHoliday().getCustomResourcesSubPath() != null : "Current themed holiday must have a theme!";
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index b24352f5f..6e3a23f1b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.texturepack;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.keyboard.KeyboardLayout;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
@@ -102,6 +103,7 @@ public class TexturePackList
 		BlockModelDispatcher.getInstance().reload();
 		ItemModelDispatcher.getInstance().reload();
 		KeyboardLayout.defaultLayout = new KeyboardLayout();
+		TooltipElement.reloadStyles(this);
 	}
 
 	public boolean updateAvailableTexturePacks() {
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 7696d6599..bfdb6820e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -11,6 +11,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.helper.Colors;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicSign;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.enums.EnumSignPicture;
@@ -33,11 +34,14 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 	public void doRender(Tessellator tessellator, TileEntitySign tileEntity, double x, double y, double z,
                          float partialTick)
     {
+        Block<?> block = tileEntity.getBlock();
+        if (block == null || !(block.getLogic() instanceof BlockLogicSign)) return; // Check to make sure the block for the entity is present before rendering, some edge cases have the tile entity loaded before the block data and can cause a crash
+
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GL11.glPushMatrix();
         float scale = 2/3f;
         GL11.glTranslatef((float)x + 0.5F, (float)y + 0.75F * scale, (float)z + 0.5F);
-        if (((BlockLogicSign) tileEntity.getBlock().getLogic()).isFreeStanding) {
+        if (((BlockLogicSign) block.getLogic()).isFreeStanding) {
             float angle = (float)(tileEntity.getBlockMeta() * 360) / 16F;
             GL11.glRotatef(-angle, 0.0F, 1.0F, 0.0F);
             modelSign.signStick.visible = true;
diff --git a/game/client/src/main/java/net/minecraft/client/render/window/GameWindow.java b/game/client/src/main/java/net/minecraft/client/render/window/GameWindow.java
index a9b0e1cd8..a451d1688 100644
--- a/game/client/src/main/java/net/minecraft/client/render/window/GameWindow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/window/GameWindow.java
@@ -37,4 +37,5 @@ public interface GameWindow {
 
 	CursorShape getCursorShape();
 
+	public long getHandle();
 }
